/* A Bison parser, made by GNU Bison 2.7.1.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         filter_expr_parse
#define yylex           filter_expr_lex
#define yyerror         filter_expr_error
#define yylval          filter_expr_lval
#define yychar          filter_expr_char
#define yydebug         filter_expr_debug
#define yynerrs         filter_expr_nerrs

/* Copy the first part of user declarations.  */


#include "ejudge/filter_tree.h"

#include "ejudge/logger.h"

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <stdarg.h>
#include <limits.h>

/* for local use */
typedef struct filter_tree *tree_t;
#define MKINT(i) filter_tree_new_int(filter_expr_tree_mem, i)
#define MKSTRING(s) filter_tree_new_string(filter_expr_tree_mem, s)
#define MKSTRING2(s) filter_tree_new_string2(filter_expr_tree_mem, s)
#define MKBOOL(b) filter_tree_new_bool(filter_expr_tree_mem, b)
#define MKDUR(u) filter_tree_new_dur(filter_expr_tree_mem, u)
#define MKTIME(a) filter_tree_new_time(filter_expr_tree_mem, a)
#define MKSIZE(z) filter_tree_new_size(filter_expr_tree_mem, z)
#define MKRESULT(r) filter_tree_new_result(filter_expr_tree_mem, r)
#define MKHASH(h) filter_tree_new_hash(filter_expr_tree_mem, h)
#define MKIP(p) filter_tree_new_ip(filter_expr_tree_mem, p)
#define MKCOPY(c) filter_tree_dup(filter_expr_tree_mem, c)

static ej_ip_t empty_ipv6;

static tree_t check_int(tree_t p);
static tree_t check_bool(tree_t p);
static tree_t check_string(tree_t p);

static tree_t do_int_cast(tree_t q, tree_t p);
static tree_t do_string_cast(tree_t, tree_t);
static tree_t do_bool_cast(tree_t, tree_t);
static tree_t do_dur_cast(tree_t, tree_t);
static tree_t do_time_cast(tree_t, tree_t);
static tree_t do_size_cast(tree_t, tree_t);
static tree_t do_result_cast(tree_t, tree_t);
static tree_t do_hash_cast(tree_t, tree_t);
static tree_t do_ip_cast(tree_t, tree_t);

static tree_t do_un_bitnot(tree_t, tree_t);
static tree_t do_un_lognot(tree_t, tree_t);
static tree_t do_un_minus(tree_t, tree_t);
static tree_t do_un_plus(tree_t, tree_t);

static tree_t do_logop(tree_t, tree_t, tree_t);
static tree_t do_equality(tree_t, tree_t, tree_t);
static tree_t do_relation(tree_t, tree_t, tree_t);
static tree_t do_regexp(tree_t, tree_t, tree_t);
static tree_t do_multiply(tree_t, tree_t, tree_t);
static tree_t do_divmod(tree_t, tree_t, tree_t);
static tree_t do_bitop(tree_t, tree_t, tree_t);
static tree_t do_add(tree_t, tree_t, tree_t);
static tree_t do_sub(tree_t, tree_t, tree_t);

static void yyerror(unsigned char const *);
static void do_error(void *, unsigned char const *format, ...);

/*
 * FIXME: filter_expr parser uses lots of static variables internally,
 *        so, it should be used with care!
 */
static struct filter_tree_mem *filter_expr_tree_mem;
static void (*filter_expr_parse_err)(void *, unsigned char const *, ...);
static void *filter_expr_user_data;

#define YYSTYPE struct filter_tree *
#define YYERROR_VERBOSE
//#define YYDEBUG 1



# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "filter_expr.h".  */
#ifndef YY_FILTER_EXPR_FILTER_EXPR_H_INCLUDED
# define YY_FILTER_EXPR_FILTER_EXPR_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int filter_expr_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_LOGOR = 258,
     TOK_LOGAND = 259,
     TOK_EQ = 260,
     TOK_NE = 261,
     TOK_LE = 262,
     TOK_GE = 263,
     TOK_ASL = 264,
     TOK_ASR = 265,
     TOK_REGEXP = 266,
     TOK_ID = 267,
     TOK_TIME = 268,
     TOK_CURTIME = 269,
     TOK_DUR = 270,
     TOK_CURDUR = 271,
     TOK_SIZE = 272,
     TOK_CURSIZE = 273,
     TOK_HASH = 274,
     TOK_CURHASH = 275,
     TOK_UUID = 276,
     TOK_CURUUID = 277,
     TOK_IP = 278,
     TOK_CURIP = 279,
     TOK_PROB = 280,
     TOK_CURPROB = 281,
     TOK_UID = 282,
     TOK_CURUID = 283,
     TOK_LOGIN = 284,
     TOK_CURLOGIN = 285,
     TOK_NAME = 286,
     TOK_CURNAME = 287,
     TOK_GROUP = 288,
     TOK_CURGROUP = 289,
     TOK_LANG = 290,
     TOK_CURLANG = 291,
     TOK_ARCH = 292,
     TOK_CURARCH = 293,
     TOK_RESULT = 294,
     TOK_CURRESULT = 295,
     TOK_SCORE = 296,
     TOK_CURSCORE = 297,
     TOK_TEST = 298,
     TOK_CURTEST = 299,
     TOK_NOW = 300,
     TOK_START = 301,
     TOK_FINISH = 302,
     TOK_TOTAL = 303,
     TOK_IMPORTED = 304,
     TOK_CURIMPORTED = 305,
     TOK_HIDDEN = 306,
     TOK_CURHIDDEN = 307,
     TOK_READONLY = 308,
     TOK_CURREADONLY = 309,
     TOK_MARKED = 310,
     TOK_CURMARKED = 311,
     TOK_SAVED = 312,
     TOK_CURSAVED = 313,
     TOK_VARIANT = 314,
     TOK_CURVARIANT = 315,
     TOK_RAWVARIANT = 316,
     TOK_CURRAWVARIANT = 317,
     TOK_USERINVISIBLE = 318,
     TOK_CURUSERINVISIBLE = 319,
     TOK_USERBANNED = 320,
     TOK_CURUSERBANNED = 321,
     TOK_USERLOCKED = 322,
     TOK_CURUSERLOCKED = 323,
     TOK_USERINCOMPLETE = 324,
     TOK_CURUSERINCOMPLETE = 325,
     TOK_USERDISQUALIFIED = 326,
     TOK_CURUSERDISQUALIFIED = 327,
     TOK_LATEST = 328,
     TOK_CURLATEST = 329,
     TOK_LATESTMARKED = 330,
     TOK_CURLATESTMARKED = 331,
     TOK_AFTEROK = 332,
     TOK_CURAFTEROK = 333,
     TOK_EXAMINABLE = 334,
     TOK_CUREXAMINABLE = 335,
     TOK_EXAMINATOR = 336,
     TOK_CUREXAMINATOR = 337,
     TOK_CYPHER = 338,
     TOK_CURCYPHER = 339,
     TOK_MISSINGSOURCE = 340,
     TOK_CURMISSINGSOURCE = 341,
     TOK_JUDGE_ID = 342,
     TOK_CURJUDGE_ID = 343,
     TOK_TOTAL_SCORE = 344,
     TOK_CURTOTAL_SCORE = 345,
     TOK_INUSERGROUP = 346,
     TOK_PASSED_MODE = 347,
     TOK_CURPASSED_MODE = 348,
     TOK_EOLN_TYPE = 349,
     TOK_CUREOLN_TYPE = 350,
     TOK_STORE_FLAGS = 351,
     TOK_CURSTORE_FLAGS = 352,
     TOK_TOKEN_FLAGS = 353,
     TOK_CURTOKEN_FLAGS = 354,
     TOK_TOKEN_COUNT = 355,
     TOK_CURTOKEN_COUNT = 356,
     TOK_INUSERGROUPINT = 357,
     TOK_INT = 358,
     TOK_STRING = 359,
     TOK_BOOL = 360,
     TOK_TIME_T = 361,
     TOK_DUR_T = 362,
     TOK_SIZE_T = 363,
     TOK_RESULT_T = 364,
     TOK_HASH_T = 365,
     TOK_IP_T = 366,
     TOK_INT_L = 367,
     TOK_STRING_L = 368,
     TOK_BOOL_L = 369,
     TOK_TIME_L = 370,
     TOK_DUR_L = 371,
     TOK_SIZE_L = 372,
     TOK_RESULT_L = 373,
     TOK_HASH_L = 374,
     TOK_IP_L = 375,
     TOK_UN_MINUS = 376
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE filter_expr_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int filter_expr_parse (void *YYPARSE_PARAM);
#else
int filter_expr_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int filter_expr_parse (void);
#else
int filter_expr_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_FILTER_EXPR_FILTER_EXPR_H_INCLUDED  */

/* Copy the second part of user declarations.  */



#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if (! defined __GNUC__ || __GNUC__ < 2 \
      || (__GNUC__ == 2 && __GNUC_MINOR__ < 5))
#  define __attribute__(Spec) /* empty */
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif


/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  177
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   485

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  137
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  13
/* YYNRULES -- Number of rules.  */
#define YYNRULES  180
/* YYNRULES -- Number of states.  */
#define YYNSTATES  324

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   376

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   133,     2,     2,     2,   131,   124,     2,
     134,   135,   129,   127,   136,   128,     2,   130,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     125,     2,   126,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   123,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   122,     2,   132,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     6,     8,    12,    14,    18,    20,
      24,    26,    30,    32,    36,    38,    42,    46,    50,    54,
      58,    62,    66,    68,    72,    76,    78,    82,    86,    88,
      92,    96,   100,   102,   105,   108,   111,   114,   118,   120,
     122,   124,   126,   128,   130,   132,   134,   136,   138,   143,
     145,   147,   152,   154,   156,   161,   163,   165,   170,   172,
     174,   179,   181,   183,   188,   190,   192,   197,   199,   201,
     206,   208,   210,   215,   217,   219,   224,   226,   228,   233,
     235,   237,   242,   244,   246,   251,   253,   255,   260,   262,
     264,   269,   271,   273,   278,   280,   282,   287,   289,   291,
     296,   298,   300,   305,   307,   309,   314,   316,   318,   323,
     325,   327,   332,   334,   336,   341,   343,   348,   350,   352,
     357,   359,   361,   366,   368,   370,   375,   377,   379,   384,
     386,   388,   393,   395,   397,   402,   404,   406,   411,   413,
     415,   420,   422,   424,   431,   436,   441,   446,   448,   450,
     455,   457,   459,   464,   466,   468,   473,   475,   477,   482,
     484,   486,   491,   493,   495,   500,   502,   504,   506,   508,
     513,   515,   520,   525,   530,   535,   540,   545,   550,   555,
     560
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     138,     0,    -1,   139,    -1,    -1,   140,    -1,   139,     3,
     140,    -1,   141,    -1,   140,     4,   141,    -1,   142,    -1,
     141,   122,   142,    -1,   143,    -1,   142,   123,   143,    -1,
     144,    -1,   143,   124,   144,    -1,   145,    -1,   144,     5,
     145,    -1,   144,     6,   145,    -1,   144,   125,   145,    -1,
     144,     7,   145,    -1,   144,   126,   145,    -1,   144,     8,
     145,    -1,   145,    11,   145,    -1,   146,    -1,   145,     9,
     146,    -1,   145,    10,   146,    -1,   147,    -1,   146,   127,
     147,    -1,   146,   128,   147,    -1,   148,    -1,   147,   129,
     148,    -1,   147,   130,   148,    -1,   147,   131,   148,    -1,
     149,    -1,   132,   149,    -1,   133,   149,    -1,   128,   149,
      -1,   127,   149,    -1,   134,   139,   135,    -1,   113,    -1,
     112,    -1,   114,    -1,   118,    -1,    12,    -1,    45,    -1,
      46,    -1,    47,    -1,    48,    -1,    13,    -1,    13,   134,
     139,   135,    -1,    14,    -1,    15,    -1,    15,   134,   139,
     135,    -1,    16,    -1,    17,    -1,    17,   134,   139,   135,
      -1,    18,    -1,    19,    -1,    19,   134,   139,   135,    -1,
      20,    -1,    21,    -1,    21,   134,   139,   135,    -1,    22,
      -1,    23,    -1,    23,   134,   139,   135,    -1,    24,    -1,
      27,    -1,    27,   134,   139,   135,    -1,    28,    -1,    29,
      -1,    29,   134,   139,   135,    -1,    30,    -1,    31,    -1,
      31,   134,   139,   135,    -1,    32,    -1,    33,    -1,    33,
     134,   139,   135,    -1,    34,    -1,    35,    -1,    35,   134,
     139,   135,    -1,    36,    -1,    37,    -1,    37,   134,   139,
     135,    -1,    38,    -1,    25,    -1,    25,   134,   139,   135,
      -1,    26,    -1,    39,    -1,    39,   134,   139,   135,    -1,
      40,    -1,    41,    -1,    41,   134,   139,   135,    -1,    42,
      -1,    43,    -1,    43,   134,   139,   135,    -1,    44,    -1,
      49,    -1,    49,   134,   139,   135,    -1,    50,    -1,    51,
      -1,    51,   134,   139,   135,    -1,    52,    -1,    53,    -1,
      53,   134,   139,   135,    -1,    54,    -1,    55,    -1,    55,
     134,   139,   135,    -1,    56,    -1,    57,    -1,    57,   134,
     139,   135,    -1,    58,    -1,    59,    -1,    59,   134,   139,
     135,    -1,    60,    -1,    61,    -1,    61,   134,   139,   135,
      -1,    62,    -1,    63,   134,   139,   135,    -1,    63,    -1,
      64,    -1,    65,   134,   139,   135,    -1,    65,    -1,    66,
      -1,    67,   134,   139,   135,    -1,    67,    -1,    68,    -1,
      69,   134,   139,   135,    -1,    69,    -1,    70,    -1,    71,
     134,   139,   135,    -1,    71,    -1,    72,    -1,    73,   134,
     139,   135,    -1,    73,    -1,    74,    -1,    75,   134,   139,
     135,    -1,    75,    -1,    76,    -1,    77,   134,   139,   135,
      -1,    77,    -1,    78,    -1,    79,   134,   139,   135,    -1,
      79,    -1,    80,    -1,    81,   134,   139,   136,   139,   135,
      -1,    81,   134,   139,   135,    -1,    82,   134,   139,   135,
      -1,    85,   134,   139,   135,    -1,    85,    -1,    86,    -1,
      87,   134,   139,   135,    -1,    87,    -1,    88,    -1,    92,
     134,   139,   135,    -1,    92,    -1,    93,    -1,    94,   134,
     139,   135,    -1,    94,    -1,    95,    -1,    96,   134,   139,
     135,    -1,    96,    -1,    97,    -1,    98,   134,   139,   135,
      -1,    98,    -1,    99,    -1,   100,   134,   139,   135,    -1,
     100,    -1,   101,    -1,    89,    -1,    83,    -1,    83,   134,
     139,   135,    -1,    84,    -1,    91,   134,   139,   135,    -1,
     103,   134,   139,   135,    -1,   104,   134,   139,   135,    -1,
     105,   134,   139,   135,    -1,   106,   134,   139,   135,    -1,
     107,   134,   139,   135,    -1,   108,   134,   139,   135,    -1,
     109,   134,   139,   135,    -1,   110,   134,   139,   135,    -1,
     111,   134,   139,   135,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   211,   211,   212,   216,   217,   221,   222,   226,   227,
     231,   232,   236,   237,   241,   242,   243,   244,   245,   246,
     247,   248,   252,   253,   254,   258,   259,   260,   264,   265,
     266,   267,   271,   272,   273,   274,   275,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "\"||\"", "\"&&\"", "\"==\"", "\"!=\"",
  "\"<=\"", "\">=\"", "\"<<\"", "\">>\"", "\"~=\"", "\"id\"", "\"time\"",
  "\"curtime\"", "\"dur\"", "\"curdur\"", "\"size\"", "\"cursize\"",
  "\"hash\"", "\"curhash\"", "\"uuid\"", "\"curuuid\"", "\"ip\"",
  "\"curip\"", "\"prob\"", "\"curprob\"", "\"uid\"", "\"curuid\"",
  "\"login\"", "\"curlogin\"", "\"name\"", "\"curname\"", "\"group\"",
  "\"curgroup\"", "\"lang\"", "\"curlang\"", "\"arch\"", "\"curarch\"",
  "\"result\"", "\"curresult\"", "\"score\"", "\"curscore\"", "\"test\"",
  "\"curtest\"", "\"now\"", "\"start\"", "\"finish\"", "\"total\"",
  "\"imported\"", "\"curimported\"", "\"hidden\"", "\"curhidden\"",
  "\"readonly\"", "\"curreadonly\"", "\"marked\"", "\"curmarked\"",
  "\"saved\"", "\"cursaved\"", "\"variant\"", "\"curvariant\"",
  "\"rawvariant\"", "\"currawvariant\"", "\"userinvisible\"",
  "\"curuserinvisible\"", "\"userbanned\"", "\"curuserbanned\"",
  "\"userlocked\"", "\"curuserlocked\"", "\"userincomplete\"",
  "\"curuserincomplete\"", "\"userdisqualified\"",
  "\"curuserdisqualified\"", "\"latest\"", "\"curlatest\"",
  "\"latestmarked\"", "\"curlatestmarked\"", "\"afterok\"",
  "\"curafterok\"", "\"examinable\"", "\"curexaminable\"",
  "\"examinator\"", "\"curexaminator\"", "\"cypher\"", "\"curcypher\"",
  "\"missingsource\"", "\"curmissingsource\"", "\"judge_id\"",
  "\"curjudge_id\"", "\"total_score\"", "\"curtotal_score\"",
  "\"inusergroup\"", "\"passed_mode\"", "\"curpassed_mode\"",
  "\"eoln_type\"", "\"cureoln_type\"", "\"store_flags\"",
  "\"curstore_flags\"", "\"token_flags\"", "\"curtoken_flags\"",
  "\"token_count\"", "\"curtoken_count\"", "TOK_INUSERGROUPINT", "\"int\"",
  "\"string\"", "\"bool\"", "\"time_t\"", "\"dur_t\"", "\"size_t\"",
  "\"result_t\"", "\"hash_t\"", "\"ip_t\"", "TOK_INT_L", "TOK_STRING_L",
  "TOK_BOOL_L", "TOK_TIME_L", "TOK_DUR_L", "TOK_SIZE_L", "TOK_RESULT_L",
  "TOK_HASH_L", "TOK_IP_L", "TOK_UN_MINUS", "'|'", "'^'", "'&'", "'<'",
  "'>'", "'+'", "'-'", "'*'", "'/'", "'%'", "'~'", "'!'", "'('", "')'",
  "','", "$accept", "filter_expr", "expr0", "expr1", "expr2", "expr3",
  "expr4", "expr5", "expr6", "expr7", "expr8", "expr9", "exprA", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   124,    94,    38,    60,    62,    43,    45,    42,
      47,    37,   126,    33,    40,    41,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   137,   138,   138,   139,   139,   140,   140,   141,   141,
     142,   142,   143,   143,   144,   144,   144,   144,   144,   144,
     144,   144,   145,   145,   145,   146,   146,   146,   147,   147,
     147,   147,   148,   148,   148,   148,   148,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     1,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     3,     3,     3,     3,
       3,     3,     1,     3,     3,     1,     3,     3,     1,     3,
       3,     3,     1,     2,     2,     2,     2,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     1,
       1,     4,     1,     1,     4,     1,     1,     4,     1,     1,
       4,     1,     1,     4,     1,     1,     4,     1,     1,     4,
       1,     1,     4,     1,     1,     4,     1,     1,     4,     1,
       1,     4,     1,     1,     4,     1,     1,     4,     1,     1,
       4,     1,     1,     4,     1,     1,     4,     1,     1,     4,
       1,     1,     4,     1,     1,     4,     1,     1,     4,     1,
       1,     4,     1,     1,     4,     1,     4,     1,     1,     4,
       1,     1,     4,     1,     1,     4,     1,     1,     4,     1,
       1,     4,     1,     1,     4,     1,     1,     4,     1,     1,
       4,     1,     1,     6,     4,     4,     4,     1,     1,     4,
       1,     1,     4,     1,     1,     4,     1,     1,     4,     1,
       1,     4,     1,     1,     4,     1,     1,     1,     1,     4,
       1,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,    42,    47,    49,    50,    52,    53,    55,    56,    58,
      59,    61,    62,    64,    83,    85,    65,    67,    68,    70,
      71,    73,    74,    76,    77,    79,    80,    82,    86,    88,
      89,    91,    92,    94,    43,    44,    45,    46,    95,    97,
      98,   100,   101,   103,   104,   106,   107,   109,   110,   112,
     113,   115,   117,   118,   120,   121,   123,   124,   126,   127,
     129,   130,   132,   133,   135,   136,   138,   139,   141,   142,
       0,     0,   168,   170,   147,   148,   150,   151,   167,     0,
     153,   154,   156,   157,   159,   160,   162,   163,   165,   166,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    39,
      38,    40,    41,     0,     0,     0,     0,     0,     0,     2,
       4,     6,     8,    10,    12,    14,    22,    25,    28,    32,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,    35,    33,    34,     0,     1,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    37,
       5,     7,     9,    11,    13,    15,    16,    18,    20,    17,
      19,    23,    24,    21,    26,    27,    29,    30,    31,    48,
      51,    54,    57,    60,    63,    84,    66,    69,    72,    75,
      78,    81,    87,    90,    93,    96,    99,   102,   105,   108,
     111,   114,   116,   119,   122,   125,   128,   131,   134,   137,
     140,   144,     0,   145,   169,   146,   149,   171,   152,   155,
     158,   161,   164,   172,   173,   174,   175,   176,   177,   178,
     179,   180,     0,   143
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -133
static const yytype_int16 yypact[] =
{
     228,  -133,  -132,  -133,    15,  -133,    16,  -133,    17,  -133,
      18,  -133,    19,  -133,    20,  -133,    21,  -133,    22,  -133,
      23,  -133,    24,  -133,    25,  -133,    26,  -133,    27,  -133,
      28,  -133,    29,  -133,  -133,  -133,  -133,  -133,    30,  -133,
      31,  -133,    32,  -133,    33,  -133,    34,  -133,    35,  -133,
      36,  -133,    37,  -133,    38,  -133,    39,  -133,    40,  -133,
      41,  -133,    42,  -133,    43,  -133,    44,  -133,    45,  -133,
      46,    47,    48,  -133,    49,  -133,    50,  -133,  -133,    51,
      52,  -133,    53,  -133,    54,  -133,    55,  -133,    56,  -133,
      57,    58,    59,    60,   184,   196,   209,   210,   211,  -133,
    -133,  -133,  -133,   351,   351,   351,   351,   228,   132,   193,
     347,   230,   231,   229,   342,   112,   -13,    -5,  -133,  -133,
     228,   228,   228,   228,   228,   228,   228,   228,   228,   228,
     228,   228,   228,   228,   228,   228,   228,   228,   228,   228,
     228,   228,   228,   228,   228,   228,   228,   228,   228,   228,
     228,   228,   228,   228,   228,   228,   228,   228,   228,   228,
     228,   228,   228,   228,   228,   228,   228,   228,   228,   228,
     228,   228,  -133,  -133,  -133,  -133,     0,  -133,   228,   228,
     228,   228,   228,   228,   228,   228,   228,   228,   228,   228,
     228,   228,   228,   228,   228,   228,   228,     1,     2,     3,
       4,     5,     6,     7,     8,     9,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    -2,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,  -133,
     347,   230,   231,   229,   342,   121,   121,   121,   121,   121,
     121,   -13,   -13,   121,    -5,    -5,  -133,  -133,  -133,  -133,
    -133,  -133,  -133,  -133,  -133,  -133,  -133,  -133,  -133,  -133,
    -133,  -133,  -133,  -133,  -133,  -133,  -133,  -133,  -133,  -133,
    -133,  -133,  -133,  -133,  -133,  -133,  -133,  -133,  -133,  -133,
    -133,  -133,   228,  -133,  -133,  -133,  -133,  -133,  -133,  -133,
    -133,  -133,  -133,  -133,  -133,  -133,  -133,  -133,  -133,  -133,
    -133,  -133,   104,  -133
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -133,  -133,  -107,   179,   180,   178,   260,   271,   -75,   -44,
     -45,   -67,    14
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
     176,   178,   120,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   255,   256,
     257,   258,   259,   260,   192,   193,   263,   172,   173,   174,
     175,   189,   190,   191,   194,   195,   196,   266,   267,   268,
     189,   190,   177,   301,   302,   249,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   261,   262,   264,   265,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   322,   178,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   323,
       1,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,   167,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
     168,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   169,   170,   171,   102,   183,   184,   185,
     186,   179,   180,   182,   181,   103,   104,   250,   252,   251,
     105,   106,   107,     1,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,   253,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,   254,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,     0,   187,   188,   102,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   107
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-133)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
     107,     3,   134,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,   183,   184,
     185,   186,   187,   188,   127,   128,   191,   103,   104,   105,
     106,     9,    10,    11,   129,   130,   131,   194,   195,   196,
       9,    10,     0,   135,   136,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   189,   190,   192,   193,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   134,   134,   302,     3,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,   134,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     134,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   134,   134,   134,   118,     5,     6,     7,
       8,     4,   122,   124,   123,   127,   128,   178,   180,   179,
     132,   133,   134,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,   181,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   182,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,    -1,   125,   126,   118,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   134
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   118,   127,   128,   132,   133,   134,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   149,   149,   149,   149,   139,     0,     3,     4,
     122,   123,   124,     5,     6,     7,     8,   125,   126,     9,
      10,    11,   127,   128,   129,   130,   131,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   135,
     140,   141,   142,   143,   144,   145,   145,   145,   145,   145,
     145,   146,   146,   145,   147,   147,   148,   148,   148,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   136,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   139,   135
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YYUSE (yytype);
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

    { yylval = (yyvsp[(1) - (1)]); }
    break;

  case 3:

    { yylval = 0; }
    break;

  case 4:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 5:

    { (yyval) = do_logop((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 6:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 7:

    { (yyval) = do_logop((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 8:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 9:

    { (yyval) = do_bitop((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 10:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 11:

    { (yyval) = do_bitop((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 12:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 13:

    { (yyval) = do_bitop((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 14:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 15:

    { (yyval) = do_equality((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 16:

    { (yyval) = do_equality((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 17:

    { (yyval) = do_relation((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 18:

    { (yyval) = do_relation((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 19:

    { (yyval) = do_relation((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 20:

    { (yyval) = do_relation((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 21:

    { (yyval) = do_regexp((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 22:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 23:

    { (yyval) = do_bitop((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 24:

    { (yyval) = do_bitop((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 25:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 26:

    { (yyval) = do_add((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 27:

    { (yyval) = do_sub((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 28:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 29:

    { (yyval) = do_multiply((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 30:

    { (yyval) = do_divmod((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 31:

    { (yyval) = do_divmod((yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 32:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 33:

    { (yyval) = do_un_bitnot((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)])); }
    break;

  case 34:

    { (yyval) = do_un_lognot((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)])); }
    break;

  case 35:

    { (yyval) = do_un_minus((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)])); }
    break;

  case 36:

    { (yyval) = do_un_plus((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)])); }
    break;

  case 37:

    { (yyval) = (yyvsp[(2) - (3)]); }
    break;

  case 38:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 39:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 40:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 41:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 42:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 43:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 44:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 45:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 46:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 47:

    { (yyvsp[(1) - (1)])->kind = TOK_CURTIME; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 48:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 49:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 50:

    { (yyvsp[(1) - (1)])->kind = TOK_CURDUR; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 51:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 52:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 53:

    { (yyvsp[(1) - (1)])->kind = TOK_CURSIZE; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 54:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 55:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 56:

    { (yyvsp[(1) - (1)])->kind = TOK_CURHASH; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 57:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 58:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 59:

    { (yyvsp[(1) - (1)])->kind = TOK_CURUUID; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 60:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 61:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 62:

    { (yyvsp[(1) - (1)])->kind = TOK_CURIP; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 63:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 64:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 65:

    { (yyvsp[(1) - (1)])->kind = TOK_CURUID; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 66:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 67:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 68:

    { (yyvsp[(1) - (1)])->kind = TOK_CURLOGIN; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 69:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 70:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 71:

    { (yyvsp[(1) - (1)])->kind = TOK_CURNAME; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 72:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 73:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 74:

    { (yyvsp[(1) - (1)])->kind = TOK_CURGROUP; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 75:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 76:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 77:

    { (yyvsp[(1) - (1)])->kind = TOK_CURLANG; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 78:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 79:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 80:

    { (yyvsp[(1) - (1)])->kind = TOK_CURARCH; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 81:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 82:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 83:

    { (yyvsp[(1) - (1)])->kind = TOK_CURPROB; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 84:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 85:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 86:

    { (yyvsp[(1) - (1)])->kind = TOK_CURRESULT; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 87:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 88:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 89:

    { (yyvsp[(1) - (1)])->kind = TOK_CURSCORE; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 90:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 91:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 92:

    { (yyvsp[(1) - (1)])->kind = TOK_CURTEST; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 93:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 94:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 95:

    { (yyvsp[(1) - (1)])->kind = TOK_CURIMPORTED; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 96:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 97:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 98:

    { (yyvsp[(1) - (1)])->kind = TOK_CURHIDDEN; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 99:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 100:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 101:

    { (yyvsp[(1) - (1)])->kind = TOK_CURREADONLY; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 102:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 103:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 104:

    { (yyvsp[(1) - (1)])->kind = TOK_CURMARKED; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 105:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 106:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 107:

    { (yyvsp[(1) - (1)])->kind = TOK_CURSAVED; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 108:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 109:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 110:

    { (yyvsp[(1) - (1)])->kind = TOK_CURVARIANT; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 111:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 112:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 113:

    { (yyvsp[(1) - (1)])->kind = TOK_CURRAWVARIANT; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 114:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 115:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 116:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 117:

    { (yyvsp[(1) - (1)])->kind = TOK_CURUSERINVISIBLE; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 118:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 119:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 120:

    { (yyvsp[(1) - (1)])->kind = TOK_CURUSERBANNED; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 121:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 122:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 123:

    { (yyvsp[(1) - (1)])->kind = TOK_CURUSERLOCKED; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 124:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 125:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 126:

    { (yyvsp[(1) - (1)])->kind = TOK_CURUSERINCOMPLETE; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 127:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 128:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 129:

    { (yyvsp[(1) - (1)])->kind = TOK_CURUSERDISQUALIFIED; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 130:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 131:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 132:

    { (yyvsp[(1) - (1)])->kind = TOK_CURLATEST; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 133:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 134:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 135:

    { (yyvsp[(1) - (1)])->kind = TOK_CURLATESTMARKED; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 136:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 137:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 138:

    { (yyvsp[(1) - (1)])->kind = TOK_CURAFTEROK; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 139:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 140:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 141:

    { (yyvsp[(1) - (1)])->kind = TOK_CUREXAMINABLE; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 142:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 143:

    { (yyvsp[(1) - (6)])->v.t[0] = check_int((yyvsp[(3) - (6)])); (yyvsp[(1) - (6)])->v.t[1] = check_int((yyvsp[(5) - (6)])); (yyval) = (yyvsp[(1) - (6)]); }
    break;

  case 144:

    { (yyvsp[(1) - (4)])->kind = TOK_CUREXAMINATOR; (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 145:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 146:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 147:

    { (yyvsp[(1) - (1)])->kind = TOK_CURMISSINGSOURCE; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 148:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 149:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 150:

    { (yyvsp[(1) - (1)])->kind = TOK_CURJUDGE_ID; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 151:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 152:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 153:

    { (yyvsp[(1) - (1)])->kind = TOK_CURPASSED_MODE; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 154:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 155:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 156:

    { (yyvsp[(1) - (1)])->kind = TOK_CUREOLN_TYPE; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 157:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 158:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 159:

    { (yyvsp[(1) - (1)])->kind = TOK_CURSTORE_FLAGS; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 160:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 161:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 162:

    { (yyvsp[(1) - (1)])->kind = TOK_CURTOKEN_FLAGS; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 163:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 164:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 165:

    { (yyvsp[(1) - (1)])->kind = TOK_CURTOKEN_COUNT; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 166:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 167:

    { (yyvsp[(1) - (1)])->kind = TOK_CURTOTAL_SCORE; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 168:

    { (yyvsp[(1) - (1)])->kind = TOK_CURCYPHER; (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 169:

    { (yyvsp[(1) - (4)])->v.t[0] = check_int((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 170:

    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 171:

    { (yyvsp[(1) - (4)])->v.t[0] = check_string((yyvsp[(3) - (4)])); (yyval) = (yyvsp[(1) - (4)]); }
    break;

  case 172:

    { (yyval) = do_int_cast((yyvsp[(1) - (4)]), (yyvsp[(3) - (4)])); }
    break;

  case 173:

    { (yyval) = do_string_cast((yyvsp[(1) - (4)]), (yyvsp[(3) - (4)])); }
    break;

  case 174:

    { (yyval) = do_bool_cast((yyvsp[(1) - (4)]), (yyvsp[(3) - (4)])); }
    break;

  case 175:

    { (yyval) = do_time_cast((yyvsp[(1) - (4)]), (yyvsp[(3) - (4)])); }
    break;

  case 176:

    { (yyval) = do_dur_cast((yyvsp[(1) - (4)]), (yyvsp[(3) - (4)])); }
    break;

  case 177:

    { (yyval) = do_size_cast((yyvsp[(1) - (4)]), (yyvsp[(3) - (4)])); }
    break;

  case 178:

    { (yyval) = do_result_cast((yyvsp[(1) - (4)]), (yyvsp[(3) - (4)])); }
    break;

  case 179:

    { (yyval) = do_hash_cast((yyvsp[(1) - (4)]), (yyvsp[(3) - (4)])); }
    break;

  case 180:

    { (yyval) = do_ip_cast((yyvsp[(1) - (4)]), (yyvsp[(3) - (4)])); }
    break;



      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}





static void
do_error(void *data, const unsigned char *format, ...)
{
  va_list args;
  //fprintf(stderr, "filter_expr: ");
  va_start(args, format);
  vfprintf(stderr, format, args);
  va_end(args);
  fprintf(stderr, "\n");
  yynerrs++;
}

static tree_t
check_int(tree_t p)
{
  ASSERT(p);
  if (p->type != FILTER_TYPE_INT) {
    (*filter_expr_parse_err)(filter_expr_user_data, "'int' expression expected");
    yynerrs++;
    return MKINT(0);
  }
  return p;
}
static tree_t
check_bool(tree_t p)
{
  ASSERT(p);
  if (p->type != FILTER_TYPE_BOOL) {
    (*filter_expr_parse_err)(filter_expr_user_data, "'bool' expression expected");
    yynerrs++;
    return MKBOOL(0);
  }
  return p;
}
static tree_t
check_string(tree_t p)
{
  ASSERT(p);
  if (p->type != FILTER_TYPE_STRING) {
    (*filter_expr_parse_err)(filter_expr_user_data, "'string' expression expected");
    yynerrs++;
    return MKSTRING("");
  }
  return p;
}

static tree_t
do_un_plus(tree_t op, tree_t p)
{
  p = check_int(p);
  return p;
}

static tree_t
do_un_minus(tree_t op, tree_t p)
{
  p = check_int(p);
  if (p->kind == TOK_INT_L) {
    tree_t res = MKINT(0);
    int n;

    n = filter_tree_eval_node(filter_expr_tree_mem, TOK_UN_MINUS, res, p, 0);
    if (n < 0) (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-n));
    return res;
  }
  op->kind = TOK_UN_MINUS;
  op->type = FILTER_TYPE_INT;
  op->v.t[0] = p;
  return op;
}

static tree_t
do_un_bitnot(tree_t op, tree_t p)
{
  p = check_int(p);
  if (p->kind == TOK_INT_L) {
    tree_t res = MKINT(0);
    int n;

    n = filter_tree_eval_node(filter_expr_tree_mem, '~', res, p, 0);
    if (n < 0) (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-n));
    return res;
  }
  op->kind = '~';
  op->type = FILTER_TYPE_INT;
  op->v.t[0] = p;
  return op;
}

static tree_t
do_un_lognot(tree_t op, tree_t p)
{
  p = check_bool(p);
  if (p->kind == TOK_BOOL_L) {
    tree_t res = MKBOOL(0);
    int n;

    n = filter_tree_eval_node(filter_expr_tree_mem, '!', res, p, 0);
    if (n < 0) (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-n));
    return res;
  }
  op->kind = '!';
  op->type = FILTER_TYPE_BOOL;
  op->v.t[0] = p;
  return op;
}

static tree_t
do_sub(tree_t op, tree_t p1, tree_t p2)
{
  ASSERT(op);
  ASSERT(p1);
  ASSERT(p2);

  if (p1->type != FILTER_TYPE_INT && p1->type != FILTER_TYPE_TIME
      && p1->type != FILTER_TYPE_DUR && p1->type != FILTER_TYPE_SIZE) {
    goto undefined_op;
  }
  if (p2->type != FILTER_TYPE_INT && p2->type != FILTER_TYPE_TIME
      && p2->type != FILTER_TYPE_DUR && p2->type != FILTER_TYPE_SIZE) {
    goto undefined_op;
  }

  /* int dur_t time_t size_t */
  if (p1->type == FILTER_TYPE_SIZE && p2->type == FILTER_TYPE_SIZE) {
    op->type = FILTER_TYPE_INT;
  } else if (p1->type == FILTER_TYPE_SIZE && p2->type == FILTER_TYPE_INT) {
    op->type = FILTER_TYPE_SIZE;
  } else if (p1->type == FILTER_TYPE_SIZE || p2->type == FILTER_TYPE_SIZE) {
    goto undefined_op;
  } else if (p1->type == FILTER_TYPE_TIME && p2->type == FILTER_TYPE_TIME) {
    op->type = FILTER_TYPE_DUR;
  } else if (p2->type == FILTER_TYPE_TIME) {
    goto undefined_op;
  } else if (p1->type == FILTER_TYPE_TIME && p2->type == FILTER_TYPE_INT) {
    op->type = FILTER_TYPE_TIME;
  } else if (p1->type == FILTER_TYPE_TIME && p2->type == FILTER_TYPE_DUR) {
    op->type = FILTER_TYPE_TIME;
  } else if (p1->type == FILTER_TYPE_DUR || p2->type == FILTER_TYPE_DUR) {
    op->type = FILTER_TYPE_DUR;
  } else {
    op->type = FILTER_TYPE_INT;
  }

  if (filter_tree_is_value_node(p1) && filter_tree_is_value_node(p2)) {
    struct filter_tree *res = MKINT(0);
    int r;

    r = filter_tree_eval_node(filter_expr_tree_mem, '-', res, p1, p2);
    if (r < 0) (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
    return res;
  }

  op->v.t[0] = p1;
  op->v.t[1] = p2;
  return op;

 undefined_op:
  (*filter_expr_parse_err)(filter_expr_user_data, "operation -(%s,%s) is not defined",
           filter_tree_type_to_str(p1->type),
           filter_tree_type_to_str(p2->type));
  return MKINT(0);
}

static tree_t
do_add(tree_t op, tree_t p1, tree_t p2)
{
  ASSERT(op);
  ASSERT(p1);
  ASSERT(p2);

  if (p1->type == FILTER_TYPE_HASH || p2->type == FILTER_TYPE_HASH
      || p1->type == FILTER_TYPE_IP || p2->type == FILTER_TYPE_IP
      || p1->type == FILTER_TYPE_RESULT || p2->type == FILTER_TYPE_RESULT
      || p1->type == FILTER_TYPE_BOOL || p2->type == FILTER_TYPE_BOOL) {
    goto undefined_op;
  }
  /* int string time_t dur_t size_t*/
  if (p1->type == FILTER_TYPE_STRING && p2->type == FILTER_TYPE_STRING) {
    op->type = FILTER_TYPE_STRING;
  } else if (p1->type == FILTER_TYPE_STRING || p2->type == FILTER_TYPE_STRING){
    goto undefined_op;
  } else if (p1->type == FILTER_TYPE_SIZE && p2->type == FILTER_TYPE_SIZE) {
    op->type = FILTER_TYPE_SIZE;
  } else if (p1->type == FILTER_TYPE_SIZE && p2->type == FILTER_TYPE_INT) {
    op->type = FILTER_TYPE_SIZE;
  } else if (p1->type == FILTER_TYPE_INT && p2->type == FILTER_TYPE_SIZE) {
    op->type = FILTER_TYPE_SIZE;
  } else if (p1->type == FILTER_TYPE_SIZE || p2->type == FILTER_TYPE_SIZE) {
    goto undefined_op;
  } else if (p1->type == FILTER_TYPE_TIME && p2->type == FILTER_TYPE_TIME) {
    goto undefined_op;
  } else if (p1->type == FILTER_TYPE_TIME || p2->type == FILTER_TYPE_TIME) {
    op->type = FILTER_TYPE_TIME;
  } else if (p1->type == FILTER_TYPE_DUR || p2->type == FILTER_TYPE_DUR) {
    op->type = FILTER_TYPE_DUR;
  } else {
    op->type = FILTER_TYPE_INT;
  }

  if (filter_tree_is_value_node(p1) && filter_tree_is_value_node(p2)) {
    struct filter_tree *res = MKINT(0);
    int r;

    r = filter_tree_eval_node(filter_expr_tree_mem, '+', res, p1, p2);
    if (r < 0) (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
    return res;
  }

  op->v.t[0] = p1;
  op->v.t[1] = p2;
  return op;

 undefined_op:
  (*filter_expr_parse_err)(filter_expr_user_data, "operation +(%s,%s) is not defined",
           filter_tree_type_to_str(p1->type),
           filter_tree_type_to_str(p2->type));
  return MKINT(0);
}

static tree_t
do_logop(tree_t op, tree_t p1, tree_t p2)
{
  ASSERT(op);
  ASSERT(p1);
  ASSERT(p2);

  p1 = check_bool(p1);
  p2 = check_bool(p2);
  switch (op->kind) {
  case TOK_LOGOR:
    if (p1->kind == TOK_BOOL_L) {
      if (p1->v.b) return MKBOOL(1);
      else return p2;
    }
    break;
  case TOK_LOGAND:
    if (p1->kind == TOK_BOOL_L) {
      if (p1->v.b) return p2;
      else return MKBOOL(0);
    }
    break;
  default:
    SWERR(("unhandled node %d", op->kind));
  }

  op->type = FILTER_TYPE_BOOL;
  op->v.t[0] = p1;
  op->v.t[1] = p2;
  return op;
}

static tree_t
do_bitop(tree_t op, tree_t p1, tree_t p2)
{
  ASSERT(op);
  ASSERT(p1);
  ASSERT(p2);

  if (p1->type != FILTER_TYPE_INT || p2->type != FILTER_TYPE_INT) {
    (*filter_expr_parse_err)(filter_expr_user_data, "operation is not defined");
    return MKINT(0);
  }

  if (filter_tree_is_value_node(p1) && filter_tree_is_value_node(p2)) {
    struct filter_tree *res = MKINT(0);
    int r;

    r = filter_tree_eval_node(filter_expr_tree_mem, op->kind, res, p1, p2);
    if (r < 0) (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
    return res;
  }

  op->type = FILTER_TYPE_INT;
  op->v.t[0] = p1;
  op->v.t[1] = p2;
  return op;
}

static tree_t
do_equality(tree_t op, tree_t p1, tree_t p2)
{
  ASSERT(op);
  ASSERT(p1);
  ASSERT(p2);

  if (p1->type != p2->type) {
    (*filter_expr_parse_err)(filter_expr_user_data, "type mismatch");
    return MKBOOL(0);
  }

  if (filter_tree_is_value_node(p1) && filter_tree_is_value_node(p2)) {
    struct filter_tree *res = MKINT(0);
    int r;

    r = filter_tree_eval_node(filter_expr_tree_mem, op->kind, res, p1, p2);
    if (r < 0) (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
    return res;
  }

  op->type = FILTER_TYPE_BOOL;
  op->v.t[0] = p1;
  op->v.t[1] = p2;
  return op;
}

static tree_t
do_regexp(tree_t op, tree_t p1, tree_t p2)
{
  ASSERT(op);
  ASSERT(p1);
  ASSERT(p2);

  if (p1->type != FILTER_TYPE_STRING || p2->type != FILTER_TYPE_STRING) {
    (*filter_expr_parse_err)(filter_expr_user_data, "operation ~= is undefined for this type");
    return MKBOOL(0);
  }

  op->type = FILTER_TYPE_BOOL;
  op->v.t[0] = p1;
  op->v.t[1] = p2;
  return op;
}

static tree_t
do_relation(tree_t op, tree_t p1, tree_t p2)
{
  ASSERT(op);
  ASSERT(p1);
  ASSERT(p2);

  if (p1->type == FILTER_TYPE_HASH || p1->type == FILTER_TYPE_RESULT
      || p1->type == FILTER_TYPE_IP) {
    (*filter_expr_parse_err)(filter_expr_user_data, "operation is undefined for this type");
    return MKBOOL(0);
  }
  if (p1->type != p2->type) {
    (*filter_expr_parse_err)(filter_expr_user_data, "type mismatch");
    return MKBOOL(0);
  }

  if (filter_tree_is_value_node(p1) && filter_tree_is_value_node(p2)) {
    struct filter_tree *res = MKINT(0);
    int r;

    r = filter_tree_eval_node(filter_expr_tree_mem, op->kind, res, p1, p2);
    if (r < 0) (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
    return res;
  }

  op->type = FILTER_TYPE_BOOL;
  op->v.t[0] = p1;
  op->v.t[1] = p2;
  return op;
}

static tree_t
do_divmod(tree_t op, tree_t p1, tree_t p2)
{
  ASSERT(op);
  ASSERT(p1);
  ASSERT(p2);

  if (p1->type != FILTER_TYPE_INT && p1->type != FILTER_TYPE_DUR
      && p1->type != FILTER_TYPE_SIZE) {
    (*filter_expr_parse_err)(filter_expr_user_data, "%c is undefined for type %s", op->kind,
             filter_tree_type_to_str(p1->type));
    return MKINT(0);
  }
  if (p2->type != FILTER_TYPE_INT && p2->type != FILTER_TYPE_DUR
      && p2->type != FILTER_TYPE_SIZE) {
    (*filter_expr_parse_err)(filter_expr_user_data, "%c is undefined for type %s", op->kind,
             filter_tree_type_to_str(p2->type));
    return MKINT(0);
  }
  if (p1->type == FILTER_TYPE_INT && p2->type == FILTER_TYPE_INT) {
    op->type = FILTER_TYPE_INT;
  } else if (p1->type == FILTER_TYPE_SIZE && p2->type == FILTER_TYPE_SIZE) {
    op->type = FILTER_TYPE_INT;
  } else if (p1->type == FILTER_TYPE_DUR && p2->type == FILTER_TYPE_DUR) {
    op->type = FILTER_TYPE_INT;
  } else if (p1->type == FILTER_TYPE_SIZE && p2->type == FILTER_TYPE_INT) {
    op->type = FILTER_TYPE_SIZE;
  } else if (p1->type == FILTER_TYPE_DUR && p2->type == FILTER_TYPE_INT) {
    op->type = FILTER_TYPE_DUR;
  } else {
    (*filter_expr_parse_err)(filter_expr_user_data, "invalid arguments of %c", op->kind);
    return MKINT(0);
  }

  if (filter_tree_is_value_node(p1) && filter_tree_is_value_node(p2)) {
    struct filter_tree *res = MKINT(0);
    int r;

    r = filter_tree_eval_node(filter_expr_tree_mem, op->kind, res, p1, p2);
    if (r < 0) (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
    return res;
  }

  op->v.t[0] = p1;
  op->v.t[1] = p2;
  return op;
}

static tree_t
do_multiply(tree_t op, tree_t p1, tree_t p2)
{
  ASSERT(op);
  ASSERT(p1);
  ASSERT(p2);

  if (p1->type != FILTER_TYPE_INT && p1->type != FILTER_TYPE_DUR
      && p1->type != FILTER_TYPE_SIZE) {
    (*filter_expr_parse_err)(filter_expr_user_data, "* is undefined for type %s",
             filter_tree_type_to_str(p1->type));
    return MKINT(0);
  }
  if (p2->type != FILTER_TYPE_INT && p2->type != FILTER_TYPE_DUR
      && p2->type != FILTER_TYPE_SIZE) {
    (*filter_expr_parse_err)(filter_expr_user_data, "* is undefined for type %s",
             filter_tree_type_to_str(p2->type));
    return MKINT(0);
  }
  if (p1->type == FILTER_TYPE_INT && p2->type == FILTER_TYPE_INT) {
  } else if (p1->type == FILTER_TYPE_INT) {
    tree_t tmp = p1;
    p1 = p2;
    p2 = tmp;
  } else if (p2->type == FILTER_TYPE_INT) {
  } else {
    (*filter_expr_parse_err)(filter_expr_user_data, "one argument of * must be of type int");
    return MKINT(0);
  }

  if (filter_tree_is_value_node(p1) && filter_tree_is_value_node(p2)) {
    struct filter_tree *res = MKINT(0);
    int r;

    r = filter_tree_eval_node(filter_expr_tree_mem, '*', res, p1, p2);
    if (r < 0) (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
    return res;
  }

  op->kind = '*';
  op->type = p1->type;
  op->v.t[0] = p1;
  op->v.t[1] = p2;
  return op;
}

static tree_t
do_int_cast(tree_t q, tree_t p)
{
  ASSERT(p);
  if (p->kind == FILTER_TYPE_INT)
    return p;
  if (filter_tree_is_value_node(p)) {
    struct filter_tree res;
    int r;

    if ((r = filter_tree_eval_node(filter_expr_tree_mem, TOK_INT, &res, p, 0)) < 0) {
      (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
      return MKINT(0);
    }
    return MKINT(res.v.b);
  }
  q->v.t[0] = p;
  q->kind = TOK_INT;
  q->type = FILTER_TYPE_INT;
  return q;
}

static tree_t
do_bool_cast(tree_t q, tree_t p)
{
  ASSERT(p);

  if (p->type == FILTER_TYPE_BOOL)
    return p;

  if (filter_tree_is_value_node(p)) {
    struct filter_tree res;
    int r;

    if ((r = filter_tree_eval_node(filter_expr_tree_mem, TOK_BOOL, &res, p, 0)) < 0) {
      (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
      return MKBOOL(0);
    }
    return MKBOOL(res.v.b);
  }

  q->v.t[0] = p;
  q->kind = TOK_BOOL;
  q->type = FILTER_TYPE_BOOL;
  return q;
}

static tree_t
do_string_cast(tree_t q, tree_t p)
{
  ASSERT(p);
  if (p->type == FILTER_TYPE_STRING)
    return p;
  if (filter_tree_is_value_node(p)) {
    struct filter_tree res;
    int r;

    if ((r = filter_tree_eval_node(filter_expr_tree_mem, TOK_STRING, &res, p, 0)) < 0) {
      (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
      return MKSTRING("");
    }
    return MKSTRING2(res.v.s);
  }

  q->v.t[0] = p;
  q->kind = TOK_STRING;
  q->type = FILTER_TYPE_STRING;
  return q;
}

static tree_t
do_dur_cast(tree_t q, tree_t p)
{
  int r;

  if (p->type == FILTER_TYPE_DUR) {
    return p;
  }
  if (p->kind == TOK_INT_L || p->kind == TOK_STRING_L) {
    struct filter_tree res;

    if ((r = filter_tree_eval_node(filter_expr_tree_mem, TOK_DUR_T, &res, p, 0)) < 0) {
      (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
      return MKDUR(0);
    }
    return MKDUR(res.v.u);
  }
  if (p->type != FILTER_TYPE_INT
      && p->type != FILTER_TYPE_STRING) {
    (*filter_expr_parse_err)(filter_expr_user_data, "expression of type %s cannot be converted to dur_t",
             filter_tree_type_to_str(p->type));
    return MKDUR(0);
  }
  q->v.t[0] = p;
  q->kind = TOK_DUR_T;
  q->type = FILTER_TYPE_DUR;
  return q;
}

static tree_t
do_time_cast(tree_t q, tree_t p)
{
  int r;

  if (p->type == FILTER_TYPE_TIME) {
    return p;
  }
  if (p->kind == TOK_INT_L || p->kind == TOK_STRING_L) {
    struct filter_tree res;

    if ((r = filter_tree_eval_node(filter_expr_tree_mem, TOK_TIME_T, &res, p, 0)) < 0) {
      (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
      return MKTIME(0);
    }
    return MKTIME(res.v.a);
  }
  if (p->type != FILTER_TYPE_INT
      && p->type != FILTER_TYPE_STRING) {
    (*filter_expr_parse_err)(filter_expr_user_data, "expression of type %s cannot be converted to time_t",
             filter_tree_type_to_str(p->type));
    return MKTIME(0);
  }
  q->v.t[0] = p;
  q->kind = TOK_TIME_T;
  q->type = FILTER_TYPE_TIME;
  return q;
}

static tree_t
do_size_cast(tree_t q, tree_t p)
{
  int r;

  if (p->type == FILTER_TYPE_SIZE) {
    return p;
  }
  if (p->kind == TOK_STRING_L || p->kind == TOK_INT_L) {
    struct filter_tree res;

    if ((r = filter_tree_eval_node(filter_expr_tree_mem, TOK_SIZE_T, &res, p, 0)) < 0) {
      (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
      return MKSIZE(0);
    }
    return MKSIZE(res.v.z);
  }
  if (p->type != FILTER_TYPE_STRING && p->type != FILTER_TYPE_INT) {
    (*filter_expr_parse_err)(filter_expr_user_data, "expression of type %s cannot be converted to size_t",
             filter_tree_type_to_str(p->type));
    return MKSIZE(0);
  }
  q->v.t[0] = p;
  q->kind = TOK_SIZE_T;
  q->type = FILTER_TYPE_SIZE;
  return q;
}

static tree_t
do_result_cast(tree_t q, tree_t p)
{
  int r;

  if (p->type == FILTER_TYPE_RESULT) {
    return p;
  }
  if (p->kind == TOK_STRING_L || p->kind == TOK_INT_L) {
    struct filter_tree res;

    if ((r = filter_tree_eval_node(filter_expr_tree_mem, TOK_RESULT_T, &res, p, 0)) < 0) {
      (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
      return MKRESULT(0);
    }
    return MKRESULT(res.v.r);
  }
  if (p->type != FILTER_TYPE_STRING && p->type != FILTER_TYPE_INT) {
    (*filter_expr_parse_err)(filter_expr_user_data, "expression of type %s cannot be converted to result_t",
             filter_tree_type_to_str(p->type));
    return MKRESULT(0);
  }
  q->v.t[0] = p;
  q->kind = TOK_RESULT_T;
  q->type = FILTER_TYPE_RESULT;
  return q;
}

static tree_t
do_hash_cast(tree_t q, tree_t p)
{
  int r;

  if (p->type == FILTER_TYPE_HASH) {
    return p;
  }
  if (p->kind == TOK_STRING_L) {
    struct filter_tree res;

    if ((r = filter_tree_eval_node(filter_expr_tree_mem, TOK_HASH_T, &res, p, 0)) < 0) {
      (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
      return MKHASH(0);
    }
    return MKHASH(res.v.h);
  }
  if (p->type != FILTER_TYPE_STRING) {
    (*filter_expr_parse_err)(filter_expr_user_data, "expression of type %s cannot be converted to hash_t",
             filter_tree_type_to_str(p->type));
    return MKHASH(0);
  }
  q->v.t[0] = p;
  q->kind = TOK_HASH_T;
  q->type = FILTER_TYPE_HASH;
  return q;
}

static tree_t
do_ip_cast(tree_t q, tree_t p)
{
  int r;

  if (p->type == FILTER_TYPE_IP) {
    return p;
  }
  if (p->kind == TOK_STRING_L || p->kind == TOK_INT_L) {
    struct filter_tree res;

    if ((r = filter_tree_eval_node(filter_expr_tree_mem, TOK_IP_T, &res, p, 0)) < 0) {
      (*filter_expr_parse_err)(filter_expr_user_data, "%s", filter_strerror(-r));
      return MKIP(&empty_ipv6);
    }
    return MKIP(&res.v.p);
  }
  if (p->type != FILTER_TYPE_STRING && p->type != FILTER_TYPE_INT) {
    (*filter_expr_parse_err)(filter_expr_user_data, "expression of type %s cannot be converted to ip_t",
             filter_tree_type_to_str(p->type));
    return MKIP(&empty_ipv6);
  }
  q->v.t[0] = p;
  q->kind = TOK_IP_T;
  q->type = FILTER_TYPE_IP;
  return q;
}

static void
yyerror(unsigned char const *msg)
{
  (*filter_expr_parse_err)(filter_expr_user_data, "%s", msg);
}

void
filter_expr_init_parser(struct filter_tree_mem *mem,
                        void (*errfunc)(void *, unsigned char const *, ...),
                        void *user_data)
{
  filter_expr_tree_mem = mem;
  filter_expr_parse_err = errfunc;
  filter_expr_user_data = user_data;
  if (!filter_expr_parse_err) filter_expr_parse_err = do_error;
  //yydebug = 1;
}
